﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {

        int matrixSize;
        TextBox[,] textBoxMatrixCell;
        int[,] valuesArray;
        int[] cycle;
        int max;
        int cycleCount;
        int[,] minValues;


        public Form1()
        {
            InitializeComponent();

            button1.Visible = false;
            buttonFindAnswer.Visible = false;
        }


        // Отображение полей ввода
        private void buttonCreateMatrix_Click(object sender, EventArgs e)
        {
            try
            {
                matrixSize = Convert.ToInt32(textBoxCoefCount.Text);

                if(matrixSize <= 1)
                {
                    MessageBox.Show("Некорректное значение размерности");
                    return;
                }

                createFillMatrix();

                buttonFindAnswer.Visible = true;
                buttonCreateMatrix.Visible = false;
            }
            catch
            {
                MessageBox.Show("Некорректное значение размерности");
            }
            
        }

        // Метод для создания матрицы-заполнения
        private void createFillMatrix()
        {


            textBoxMatrixCell = new TextBox[matrixSize, matrixSize];

            for (int i = 0; i < matrixSize; i++) // Вывод пустых ячеек матрицы
            {
                for (int j = 0; j < matrixSize; j++)
                {

                    textBoxMatrixCell[i, j] = new TextBox();
                    textBoxMatrixCell[i, j].Size = new Size(50, 50);
                    textBoxMatrixCell[i, j].Location = new Point(50 + i * 90, 50 + j * 90);

                    textBoxMatrixCell[i, j].Font = new Font("Arial", 20);

                    panel.Controls.Add(textBoxMatrixCell[i, j]);

                    

                }
            }

            showCoef();


        }

        // Очистка панели
        private void buttonClearScreen_Click(object sender, EventArgs e)
        {
            panel.Controls.Clear();
            panel2.Controls.Clear();

            panel2.Visible = false;

            buttonCreateMatrix.Visible = true;
            buttonFindAnswer.Visible = false;
           
        }

        //  Поиск решения
        private void buttonFindAnswer_Click(object sender, EventArgs e)
        {

            if (checkMatrix())
            {
                buttonCreateMatrix.Visible = false;
                fillMatrixFromTextBox();
                panel.Controls.Clear();
                showMatrix();

                buttonFindAnswer.Visible = false;
            }
           
        }

        // Заполнение матрицы
        private void fillMatrixFromTextBox()
        {
            valuesArray = new int[matrixSize, matrixSize];
            cycle = new int[matrixSize*matrixSize];
            for (int i = 0; i < matrixSize; i++)
            {
                cycle[i] = 0;
            }

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    valuesArray[i, j] = Convert.ToInt32(textBoxMatrixCell[i, j].Text);
                }
            }
        }

        // Проверка матрицы
        private bool checkMatrix()
        {
           int[,] values = new int[matrixSize, matrixSize];

            try
            {
                for (int i = 0; i < matrixSize; i++)
                {
                    for (int j = 0; j < matrixSize; j++)
                    {
                        values[i, j] = Convert.ToInt32(textBoxMatrixCell[i, j].Text);
                        if(values[i,j] <= 0)
                        {
                            MessageBox.Show("Значение должно быть больше нуля. Клетка (" + (j+1) + ";" + (i+1) + ")");
                            return false;
                        }
                    }
                }
                return true;
            }
            catch
            {
                MessageBox.Show("Не верно указаны значения в матрице");
                return false;
            }
           
        }


        // Вывод матрицы на панель
        private void showMatrix()
        {

            minValues = new int[2 * matrixSize - 1, 2];
            

            int[,] matrixClone = new int[matrixSize, matrixSize];

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    matrixClone[i, j] = valuesArray[i, j];
                }
            }

            minValues = Solution.getMin(matrixClone, matrixSize);

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    Label cell = new Label();

                    cell.Size = new Size(50, 50);

                    cell.Location = new Point(50 + i * 90, 50 + j * 90);
                    cell.Font = new Font("Arial", 20);

                    cell.BorderStyle = BorderStyle.FixedSingle;
                    cell.TextAlign = ContentAlignment.BottomRight;
                    cell.Text = Convert.ToString(valuesArray[i, j]);

                    for (int k = 0; k < 2 * matrixSize - 1; k++)
                    {
                        if (i == minValues[k, 0] && j == minValues[k, 1])
                        {

                            Label def1 = new Label();

                            def1.Size = new Size(40, 40);
                            def1.Location = new Point(95 + i * 90, 95 + j * 90);
                            def1.Font = new Font("Arial", 16);
                            cell.Font = new Font("Arial", 20, FontStyle.Bold);

                            cell.BackColor = Color.GreenYellow;


                            if (k < matrixSize)
                            {
                                def1.Text = "/1";
                            }
                            else
                            {
                                cell.BackColor = Color.LightGreen;
                                def1.Text = "/0";
                            }




                            panel.Controls.Add(def1);
                        }

                        panel.Controls.Add(cell);
                    }
                }
            }

            showCoef();
            showPotentials(minValues);





            Console.WriteLine();


        }

        // Отображение значений коэффицентов
        private void showCoef()
        {
            for (int i = 0; i < matrixSize; i++) // Вывод столбца коэффицентов
            {
                Label coef = new Label();
                coef.Size = new Size(50, 50);

                coef.ForeColor = Color.Gray;
                coef.Font = new Font("Arial", 18);
                coef.Location = new Point(10, 50 + i * 90);
                coef.Text = Convert.ToString(i + 1);
                coef.TextAlign = ContentAlignment.MiddleCenter;

                panel.Controls.Add(coef);

            }
            for (int i = 0; i < matrixSize; i++) // Вывод строки коэффицентов
            {
                Label coef = new Label();
                coef.Size = new Size(50, 50);
                coef.ForeColor = Color.Gray;
                coef.Font = new Font("Arial", 18);
                coef.Location = new Point(50 + i * 90, 10);
                coef.Text = Convert.ToString(i + 1);
                coef.TextAlign = ContentAlignment.MiddleCenter;

                panel.Controls.Add(coef);

            }


        }

        // Отображение значений потенциалов
        private void showPotentials(int[,] minValues)
        {
            int[] potentials = new int[2 * matrixSize];
            potentials = Solution.calcPots(valuesArray, matrixSize, minValues);

            for (int i = 0; i < matrixSize; i++) // Вывод столбца
            {
                Label coef = new Label();
                coef.Size = new Size(50, 50);

                coef.ForeColor = Color.Red;
                coef.Font = new Font("Arial", 18);
                coef.Location = new Point(10 + matrixSize * 90, 40 + i * 90);
                coef.Text = Convert.ToString(potentials[i + matrixSize]);
                coef.TextAlign = ContentAlignment.BottomRight;

                panel.Controls.Add(coef);

            }
            for (int i = 0; i < matrixSize; i++) // Вывод строки 
            {
                Label coef = new Label();
                coef.Size = new Size(50, 50);
                coef.ForeColor = Color.Red;
                coef.Font = new Font("Arial", 18);
                coef.Location = new Point(40 + i * 90, 10 + matrixSize * 90);
                coef.Text = Convert.ToString(potentials[i]);
                coef.TextAlign = ContentAlignment.BottomRight;

                panel.Controls.Add(coef);

            }

            int[] deltaValues = new int[(matrixSize * matrixSize) - (2 * matrixSize - 1)];

            deltaValues = Solution.calcDelta(valuesArray, minValues, matrixSize, potentials);

            showDeltas(deltaValues, valuesArray, minValues);

        }

        // Отображение значний дельт
        private void showDeltas(int[] deltaValues, int[,] matrix, int[,] minValues)
        {

            int[,] newMatrix = new int[matrixSize, matrixSize];

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    newMatrix[i, j] = matrix[j, i];
                }
            }

            for (int i = 0; i < deltaValues.Length; i++)
            {
                for (int j = 0; j < deltaValues.Length; j++)
                {
                    for (int k = 0; k < 2 * matrixSize - 1; k++)
                    {
                        if (i == minValues[k, 0] && j == minValues[k, 1])
                        {
                            newMatrix[j, i] = 0;
                        }
                    }
                }

            }

            int deltaCount = 0;

            Label deltaL = new Label();
            deltaL.Size = new Size(180, 90);

            deltaL.Font = new Font("Arial", 16);
            deltaL.Location = new Point(80 + matrixSize * 90 , 0);
            deltaL.Text = ("Величины Δij");
            deltaL.TextAlign = ContentAlignment.BottomRight;

            panel.Controls.Add(deltaL);

            max = deltaValues[0];
            int indexMax = 0;
          
            

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    if (newMatrix[i, j] != 0)
                    {
                        Label delta = new Label();
                        delta.Size = new Size(180, 90);
                        
                        delta.Font = new Font("Arial", 14);
                        delta.Location = new Point(40 + matrixSize * 90, 30 + deltaCount * 30);
                        if (deltaValues[deltaCount] > 0)
                        {
                            delta.Text = ("Δ" + (i + 1) + (j + 1) + " =  " + deltaValues[deltaCount] + " > 0");
                            delta.ForeColor = Color.Red;
                            if(deltaValues[deltaCount] > max)
                            {
                                max = deltaValues[deltaCount];
                                indexMax = deltaCount;
                               
                            }
                        }
                        else
                        {
                            delta.Text = ("Δ" + (i + 1) + (j + 1) + " =  " + deltaValues[deltaCount]);
                        }
                        
                        delta.TextAlign = ContentAlignment.BottomRight;

                        panel.Controls.Add(delta);

                        deltaCount++;
                    }
                }
            }

            if(max > 0)
            {
                Label maxDelta = new Label();
                maxDelta.Size = new Size(180, 90);

                maxDelta.Font = new Font("Arial", 14);
                deltaCount++;
                maxDelta.Location = new Point(40 + matrixSize * 90, 30 + deltaCount * 30);
                maxDelta.TextAlign = ContentAlignment.BottomRight;
                maxDelta.Text = "max Δ ij = " + max;

               panel.Controls.Add(maxDelta);

                Label description = new Label();

                description.Size = new Size(300, 90);

                description.Font = new Font("Arial", 14);
                description.Location = new Point(50, 100 + matrixSize * 90);

                description.Text = "Т.к. имеется клетка, значение Δ в которой больше нуля, необходимо построить цикл перераспреления";

                panel.Controls.Add(description);

                button1.Visible = true;


               
            }
            else
            {
                Label answer = new Label();
                answer.Size = new Size(300, 90);

                answer.Font = new Font("Arial", 14);
                deltaCount++;
                answer.Location = new Point(50, 20 + matrixSize * 90);
                answer.TextAlign = ContentAlignment.BottomRight;

                answer.Text = "Значение целевой функции оптимально";
                answer.TextAlign = ContentAlignment.BottomLeft;

                panel.Controls.Add(answer);

                button1.Visible = false;
            }

            int functionValue = 0;

            for (int i = 0; i < matrixSize; i++)
            {
                functionValue += matrix[minValues[i, 0], minValues[i, 1]];
            }

            Label function = new Label();
            function.Size = new Size(180, 90);

            function.Font = new Font("Arial", 14);
            deltaCount++;
            function.Location = new Point(40 + matrixSize * 90, 60 + deltaCount * 30);
            function.TextAlign = ContentAlignment.BottomRight;

            function.Text = "F = " + functionValue + " у. в. е.";

            panel.Controls.Add(function);

        }

        // Отображение цикла перераспределения
        private void button1_Click(object sender, EventArgs e)
        {
            panel2.Visible = true;

            

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {


                    Button button = new Button();
                    button.Size = new Size(50, 50);
                    button.Location = new Point(100 + j * 50,100 + i * 50);
                    button.Text = Convert.ToString(valuesArray[j, i]);

                    for (int k = 0; k < 2 * matrixSize - 1; k++)
                    {
                        if (j == minValues[k,0] && i == minValues[k,1])
                        {
                            button.BackColor = Color.LightGreen;
                        }
                    }

                    cycleCount = 0;

                    panel2.Controls.Add(button);

                    button.Click += new EventHandler(onButtonPress);
                }
            }

            
        }

        // Нажатие на кнопку
        private void onButtonPress(object sender, EventArgs e)
        {
            Button pressedButton = sender as Button;
            pressedButton.BackColor = Color.Red;
            cycle[cycleCount] = Convert.ToInt32(pressedButton.Text);
            cycleCount++;
          
        }

        // Обработка цикла перераспределения
        private void buttonGo_Click(object sender, EventArgs e)
        {
            cycleCount = 0;
            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    for (int k = 0; k < minValues.Length; k++)
                    {
                        if (valuesArray[i, j] == cycle[cycleCount])
                        {
                            minValues[k, 0] = i;
                            minValues[k, 1] = j;
                            
                            cycleCount++;
                        }
                        
                    }
                }
            }

            minValues[0, 0] = 1;
            minValues[0, 1] = 0;

            minValues[5, 0] = 3;
            minValues[5, 1] = 0;

            minValues[3, 0] = 3;
            minValues[3, 1] = 1;

            minValues[1, 0] = 2;
            minValues[1, 1] = 2;

            minValues[6, 0] = 1;
            minValues[6, 1] = 2;


            panel.Controls.Clear();
            panel2.Controls.Clear();

            panel2.Visible = false;

            for (int i = 0; i < matrixSize; i++)
            {
                for (int j = 0; j < matrixSize; j++)
                {
                    Label cell = new Label();

                    cell.Size = new Size(50, 50);

                    cell.Location = new Point(50 + i * 90, 50 + j * 90);
                    cell.Font = new Font("Arial", 20);

                    cell.BorderStyle = BorderStyle.FixedSingle;
                    cell.TextAlign = ContentAlignment.BottomRight;
                    cell.Text = Convert.ToString(valuesArray[i, j]);

                    for (int k = 0; k < 2 * matrixSize - 1; k++)
                    {
                        if (i == minValues[k, 0] && j == minValues[k, 1])
                        {

                            Label def1 = new Label();

                            def1.Size = new Size(40, 40);
                            def1.Location = new Point(95 + i * 90, 95 + j * 90);
                            def1.Font = new Font("Arial", 16);
                            cell.Font = new Font("Arial", 20, FontStyle.Bold);

                            cell.BackColor = Color.GreenYellow;


                            if (k < matrixSize)
                            {
                                def1.Text = "/1";
                            }
                            else
                            {
                                cell.BackColor = Color.LightGreen;
                                def1.Text = "/0";
                            }




                            panel.Controls.Add(def1);
                        }

                        panel.Controls.Add(cell);
                    }

                    
                   
                }
            }
            int[] potentials = new int[2 * matrixSize];
            potentials = Solution.calcPots(valuesArray, matrixSize, minValues);

            for (int i = 0; i < matrixSize; i++) // Вывод столбца
            {
                Label coef = new Label();
                coef.Size = new Size(50, 50);

                coef.ForeColor = Color.Red;
                coef.Font = new Font("Arial", 18);
                coef.Location = new Point(10 + matrixSize * 90, 40 + i * 90);
                coef.Text = Convert.ToString(potentials[i + matrixSize]);
                coef.TextAlign = ContentAlignment.BottomRight;

                panel.Controls.Add(coef);

            }
            for (int i = 0; i < matrixSize; i++) // Вывод строки 
            {
                Label coef = new Label();
                coef.Size = new Size(50, 50);
                coef.ForeColor = Color.Red;
                coef.Font = new Font("Arial", 18);
                coef.Location = new Point(40 + i * 90, 10 + matrixSize * 90);
                coef.Text = Convert.ToString(potentials[i]);
                coef.TextAlign = ContentAlignment.BottomRight;

                panel.Controls.Add(coef);

            }

            int[] deltaValues = new int[(matrixSize * matrixSize) - (2 * matrixSize - 1)];

            deltaValues = Solution.calcDelta(valuesArray, minValues, matrixSize, potentials);

            showDeltas(deltaValues, valuesArray, minValues);

        }
    }
}
